// Code generated by go-swagger; DO NOT EDIT.

package global_network_manager_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetTrialParams creates a new GetTrialParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTrialParams() *GetTrialParams {
	return &GetTrialParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTrialParamsWithTimeout creates a new GetTrialParams object
// with the ability to set a timeout on a request.
func NewGetTrialParamsWithTimeout(timeout time.Duration) *GetTrialParams {
	return &GetTrialParams{
		timeout: timeout,
	}
}

// NewGetTrialParamsWithContext creates a new GetTrialParams object
// with the ability to set a context for a request.
func NewGetTrialParamsWithContext(ctx context.Context) *GetTrialParams {
	return &GetTrialParams{
		Context: ctx,
	}
}

// NewGetTrialParamsWithHTTPClient creates a new GetTrialParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTrialParamsWithHTTPClient(client *http.Client) *GetTrialParams {
	return &GetTrialParams{
		HTTPClient: client,
	}
}

/*
GetTrialParams contains all the parameters to send to the API endpoint

	for the get trial operation.

	Typically these are written to a http.Request.
*/
type GetTrialParams struct {

	// OrganizationID.
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get trial params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTrialParams) WithDefaults() *GetTrialParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get trial params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTrialParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get trial params
func (o *GetTrialParams) WithTimeout(timeout time.Duration) *GetTrialParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get trial params
func (o *GetTrialParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get trial params
func (o *GetTrialParams) WithContext(ctx context.Context) *GetTrialParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get trial params
func (o *GetTrialParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get trial params
func (o *GetTrialParams) WithHTTPClient(client *http.Client) *GetTrialParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get trial params
func (o *GetTrialParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the get trial params
func (o *GetTrialParams) WithOrganizationID(organizationID string) *GetTrialParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get trial params
func (o *GetTrialParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *GetTrialParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
